| OpenCV 5.0.0alpha Open Source Computer Vision

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | List of all members
cv::OdometryFrame Class Reference

An object that keeps per-frame data for Odometry algorithms from user-provided images to algorithm-specific precalculated data. When not empty, it contains a depth image, a mask of valid pixels and a set of pyramids generated from that data. A BGR/Gray image and normals are optional. OdometryFrame is made to be used together with Odometry class to reuse precalculated data between Rt data calculations. A correct way to do that is to call Odometry::prepareFrames() on prev and next frames and then pass them to Odometry::compute() method. More...

`#include <opencv2/3d/odometry_frame.hpp>`

Collaboration diagram for cv::OdometryFrame:

## Public Member Functions
| OdometryFrame (InputArray depth=noArray(), InputArray image=noArray(), InputArray mask=noArray(), InputArray normals=noArray())
| Construct a new OdometryFrame object. All non-empty images should have the same size.
| ~OdometryFrame ()
void | getDepth (OutputArray depth) const
| Get the original user-provided depth image.
void | getGrayImage (OutputArray image) const
| Get the gray image generated from the user-provided BGR/Gray image.
void | getImage (OutputArray image) const
| Get the original user-provided BGR/Gray image.
void | getMask (OutputArray mask) const
| Get the valid pixels mask generated for the ICP calculations intersected with the user-provided mask.
void | getNormals (OutputArray normals) const
| Get the normals image either generated for the ICP calculations or user-provided.
void | getProcessedDepth (OutputArray depth) const
| Get the depth image generated from the user-provided one after conversion, rescale or filtering for ICP algorithm needs.
void | getPyramidAt (OutputArray img, OdometryFramePyramidType pyrType, size_t level) const
| Get the image generated for the ICP calculations from one of the pyramids specified by pyrType. Returns empty image if the pyramid is empty or there's no such pyramid level.
int | getPyramidLevels () const
| Get the amount of levels in pyramids (all of them if not empty should have the same number of levels) or 0 if no pyramids were prepared yet.

## Public Attributes
Ptr< Impl > | impl

## Detailed Description

An object that keeps per-frame data for Odometry algorithms from user-provided images to algorithm-specific precalculated data. When not empty, it contains a depth image, a mask of valid pixels and a set of pyramids generated from that data. A BGR/Gray image and normals are optional. OdometryFrame is made to be used together with Odometry class to reuse precalculated data between Rt data calculations. A correct way to do that is to call Odometry::prepareFrames() on prev and next frames and then pass them to Odometry::compute() method.

## Constructor & Destructor Documentation

## ◆ OdometryFrame()

cv::OdometryFrame::OdometryFrame | ( | InputArray | depth = noArray(),
|  | InputArray | image = noArray(),
|  | InputArray | mask = noArray(),
|  | InputArray | normals = noArray() )
| explicit

Python:
| cv.OdometryFrame( | [, depth[, image[, mask[, normals]]]] | ) -> | <OdometryFrame object>

Construct a new OdometryFrame object. All non-empty images should have the same size.

Parameters

  depth | A depth image, should be CV_8UC1
  image | An BGR or grayscale image (or noArray() if it's not required for used ICP algorithm). Should be CV_8UC3 or CV_8C4 if it's BGR image or CV_8UC1 if it's grayscale. If it's BGR then it's converted to grayscale image automatically.
  mask | A user-provided mask of valid pixels, should be CV_8UC1
  normals | A user-provided normals to the depth surface, should be CV_32FC4

Here is the call graph for this function:

## ◆ ~OdometryFrame()

cv::OdometryFrame::~OdometryFrame | ( |  | ) |
| inline

## Member Function Documentation

## ◆ getDepth()

void cv::OdometryFrame::getDepth | ( | OutputArray | depth | ) | const

Python:
| cv.OdometryFrame.getDepth( | [, depth] | ) -> | depth

Get the original user-provided depth image.

Parameters

  depth | Output image

## ◆ getGrayImage()

void cv::OdometryFrame::getGrayImage | ( | OutputArray | image | ) | const

Python:
| cv.OdometryFrame.getGrayImage( | [, image] | ) -> | image

Get the gray image generated from the user-provided BGR/Gray image.

Parameters

  image | Output image

## ◆ getImage()

void cv::OdometryFrame::getImage | ( | OutputArray | image | ) | const

Python:
| cv.OdometryFrame.getImage( | [, image] | ) -> | image

Get the original user-provided BGR/Gray image.

Parameters

  image | Output image

## ◆ getMask()

void cv::OdometryFrame::getMask | ( | OutputArray | mask | ) | const

Python:
| cv.OdometryFrame.getMask( | [, mask] | ) -> | mask

Get the valid pixels mask generated for the ICP calculations intersected with the user-provided mask.

Parameters

  mask | Output image

## ◆ getNormals()

void cv::OdometryFrame::getNormals | ( | OutputArray | normals | ) | const

Python:
| cv.OdometryFrame.getNormals( | [, normals] | ) -> | normals

Get the normals image either generated for the ICP calculations or user-provided.

Parameters

  normals | Output image

## ◆ getProcessedDepth()

void cv::OdometryFrame::getProcessedDepth | ( | OutputArray | depth | ) | const

Python:
| cv.OdometryFrame.getProcessedDepth( | [, depth] | ) -> | depth

Get the depth image generated from the user-provided one after conversion, rescale or filtering for ICP algorithm needs.

Parameters

  depth | Output image

## ◆ getPyramidAt()

void cv::OdometryFrame::getPyramidAt | ( | OutputArray | img,
|  | OdometryFramePyramidType | pyrType,
|  | size_t | level ) const

Python:
| cv.OdometryFrame.getPyramidAt( | pyrType, level[, img] | ) -> | img

Get the image generated for the ICP calculations from one of the pyramids specified by pyrType. Returns empty image if the pyramid is empty or there's no such pyramid level.

Parameters

  img | Output image
  pyrType | Type of pyramid
  level | Level in the pyramid

## ◆ getPyramidLevels()

int cv::OdometryFrame::getPyramidLevels | ( |  | ) | const

Python:
| cv.OdometryFrame.getPyramidLevels( |  | ) -> | retval

Get the amount of levels in pyramids (all of them if not empty should have the same number of levels) or 0 if no pyramids were prepared yet.

## Member Data Documentation

## ◆ impl

Ptr<Impl> cv::OdometryFrame::impl

The documentation for this class was generated from the following file:

- opencv2/3d/odometry_frame.hpp